'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ga = require('./adapters/ga');

var _ga2 = _interopRequireDefault(_ga);

var _umeng = require('./adapters/umeng');

var _umeng2 = _interopRequireDefault(_umeng);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GH = {
  init: function init(options) {
    if (options && options.ga) {
      _ga2.default.initialize(options.ga);
    }
    if (options && options.umeng) {
      _umeng2.default.initialize(options.umeng);
    }
  },
  setScene: function setScene(s) {
    _umeng2.default.setDimension('场景', s);
    _ga2.default.set({ dimension1: s });
  },
  setRole: function setRole(r) {
    _umeng2.default.setDimension('角色', r);
    _ga2.default.set({ dimension2: r });
  },
  setUserId: function setUserId(u) {
    _umeng2.default.setDimension('店铺编号', u);
    _ga2.default.set({ userId: u });
  },
  setUserTag: function setUserTag(t) {
    _umeng2.default.setDimension('用户标签', t);
    _ga2.default.set({ dimension4: t });
  },
  setEmp: function setEmp(e) {
    _umeng2.default.setDimension('员工', e);
    _ga2.default.set({ dimension3: e });
  },
  setVersion: function setVersion(v) {
    _umeng2.default.setDimension('版本', v);
    _ga2.default.set({ dimension5: v });
  },
  setTrial: function setTrial(t) {
    _umeng2.default.setDimension('试用用户', t);
    _ga2.default.set({ dimension6: t });
  },
  setLifeCycle: function setLifeCycle(c) {
    _umeng2.default.setDimension('生命周期', c);
    _ga2.default.set({ dimension7: c });
  },
  setClientVersion: function setClientVersion(sv) {
    _umeng2.default.setDimension('客户端版本', sv);
    _ga2.default.set({ dimension8: sv });
  },
  setPageview: function setPageview(route, referer) {
    _umeng2.default.setPageview(route, referer);
    _ga2.default.pageview(route, referer);
  },
  setEvent: function setEvent(category, action, label, value, nodeid) {
    _umeng2.default.setEvent(category, action, label, value, nodeid);
    if (_ga2.default && _ga2.default.ga) {
      _ga2.default.ga('send', 'event', category, action, label);
    }
  }
};

exports.default = GH;