'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _QMIcon2 = require('qm-ui/lib/QMIcon');

var _QMIcon3 = _interopRequireDefault(_QMIcon2);

var _tree = require('antd/lib/tree');

var _tree2 = _interopRequireDefault(_tree);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _iflux = require('iflux2');

var _ql = require('../ql');

var _webapi = require('../webapi');

var _qmArray = require('../../util/qm-array');

var _qmArray2 = _interopRequireDefault(_qmArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeNode = _tree2.default.TreeNode;
var noop = function noop() {};

var CategoryBar = (0, _iflux.Relax)(_class = (_temp = _class2 = function (_Component) {
  _inherits(CategoryBar, _Component);

  function CategoryBar() {
    _classCallCheck(this, CategoryBar);

    return _possibleConstructorReturn(this, (CategoryBar.__proto__ || Object.getPrototypeOf(CategoryBar)).apply(this, arguments));
  }

  _createClass(CategoryBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.props.elementInit({ index: 'cateId', value: '0', group: 'simple' });
      (0, _webapi.loadCategories)().then(function (res) {
        var cates = res.data;
        var leaves = [];
        res.data.push({ id: 0, pid: -1, name: '我的媒体库' });
        cates = _qmArray2.default.tree(cates, 'id', 'pid', -1, function (v) {
          if (v.NODE_LEAF) {
            leaves.push(v.id);
          }
        });
        _this2.props.initCategory(cates);
        _this2.props.initLeaves(leaves);
      });
    }
  }, {
    key: '_onSelect',
    value: function _onSelect(selectedKey) {
      if (selectedKey.length) {
        this.props.onFormReset('simple');
        this.props.expand(selectedKey[0]);
        this.props.elementOnChange({
          index: 'cateId',

          source: { index: 'cateId', value: selectedKey[0], group: 'simple' }
        });
        this.props.onRefresh();
      } else {
        this.props.expand(this.props.selected[0]);
      }
    }
  }, {
    key: '_onExpand',
    value: function _onExpand(expandedKey) {
      this.props.expand(expandedKey);
    }
  }, {
    key: 'render',
    value: function render() {
      var loop = function loop(data) {
        return data.map(function (it) {
          var item = it.toJS();
          if (item.childNodes && item.childNodes.length) {
            return _react2.default.createElement(
              TreeNode,
              {
                key: item.id,
                title: _react2.default.createElement(
                  'span',
                  null,
                  _react2.default.createElement(_QMIcon3.default, { type: 'folder' }),
                  item.name
                ) },
              loop(it.get('childNodes')).toArray()
            );
          }
          return _react2.default.createElement(TreeNode, {
            key: item.id,
            title: _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement(_QMIcon3.default, { type: 'file' }),
              item.name
            )
          });
        });
      };
      return _react2.default.createElement(
        'div',
        { className: 'folder-tree', style: { height: 417 } },
        _react2.default.createElement(
          _tree2.default,
          {
            onSelect: this._onSelect.bind(this),
            onExpand: this._onExpand.bind(this),
            expandedKeys: this.props.expanded,
            selectedKeys: this.props.selected,
            autoExpandParent: this.props.expandParent,
            defaultExpandAll: true },
          loop(this.props.categories).toArray()
        )
      );
    }
  }]);

  return CategoryBar;
}(_react.Component), _class2.defaultProps = {
  expanded: _ql.expandedQL,
  categories: _ql.cateQL,
  selected: _ql.selectedQL,
  initCategory: noop,
  onRefresh: noop,
  onFormReset: noop,
  elementOnChange: noop,
  expand: noop,
  expandParent: _ql.expandParentQL,
  elementInit: noop,
  initLeaves: noop
}, _temp)) || _class;

exports.default = CategoryBar;