'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _col = require('antd/lib/col');

var _col2 = _interopRequireDefault(_col);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp; /**
                             * @author gcy[of1518]
                             * @date 16/10/11
                             *
                             * @description QMSearchForm 通过store与其他组件（table,grid）耦合
                             */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _iflux = require('iflux2');

var _ql = require('../ql');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Search = _input2.default.Search;
var noop = function noop() {};

var SearchForm = (0, _iflux.Relax)(_class = (_temp = _class2 = function (_Component) {
  _inherits(SearchForm, _Component);

  function SearchForm(props) {
    _classCallCheck(this, SearchForm);

    return _possibleConstructorReturn(this, (SearchForm.__proto__ || Object.getPrototypeOf(SearchForm)).call(this, props));
  }

  _createClass(SearchForm, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          init = _props.init,
          children = _props.children,
          group = _props.group;

      if (!!group) {
        init({ formCurrentGroup: 'simple', formGroup: true });
      }
    }
  }, {
    key: '_onSearch',
    value: function _onSearch() {
      this.props.onCellSelectedClear();
      this.props.onFetch({ group: 'simple' });
    }
  }, {
    key: '_onChange',
    value: function _onChange(e) {
      this.props.onFormReset('simple');
      this.props.elementOnChange({
        index: 'name',
        source: { index: 'name', value: e.target.value, group: 'simple' }
      });
      this.props.onSearch(e.target.value);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _col2.default,
        { span: 8 },
        _react2.default.createElement(Search, {
          className: 'search-input',
          value: this.props.searchKey,
          placeholder: '\u6309\u6587\u4EF6\u5939/\u6587\u4EF6\u540D\u79F0\u641C\u7D22',
          onChange: this._onChange.bind(this),
          onSearch: this._onSearch.bind(this)
        })
      );
    }
  }]);

  return SearchForm;
}(_react.Component), _class2.defaultProps = {
  //protected
  formCurrentGroup: 'simple', //当前分组
  group: 'simple',

  init: noop,
  onFetch: noop, //发起请求
  onRefresh: noop, //刷新
  onFormReset: noop, //表单重置
  onReset: noop, //重置
  onFormChangeGroup: noop, //切换分组（切换高级搜索和简易搜索）
  elementOnChange: noop,
  onSearch: noop,
  onCellSelectedClear: noop,
  searchKey: _ql.searchQL,
  //private
  defaultFromData: {} //默认formData数据
}, _temp)) || _class;

exports.default = SearchForm;