'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fileTypeQL = exports.linkAddressQL = exports.selectValueQL = exports.videosQL = exports.imagesQL = exports.netImagesQL = exports.currentDataQL = exports.notCheckedQL = exports.allCheckedQL = exports.cellSelectQL = exports.cateQL = exports.selectedQL = exports.expandParentQL = exports.searchQL = exports.expandedQL = exports.uploadQL = exports.scopeQL = exports.limitQL = undefined;

var _iflux = require('iflux2');

var limitQL = exports.limitQL = (0, _iflux.QL)('limitQL', [
//查询展开的类目key
'limit', function (limit) {
  return limit;
}]);

var scopeQL = exports.scopeQL = (0, _iflux.QL)('scopeQL', [
//查询展开的类目key
'scope', function (scope) {
  return scope;
}]);

var uploadQL = exports.uploadQL = (0, _iflux.QL)('uploadQL', [
//查询展开的类目key
'upload', function (upload) {
  return upload;
}]);

var expandedQL = exports.expandedQL = (0, _iflux.QL)('expandedQL', [
//查询展开的类目key
'expanded', function (expanded) {
  return expanded;
}]);

var searchQL = exports.searchQL = (0, _iflux.QL)('searchQL', [
//查询搜索框的值
'searchKey', function (searchKey) {
  return searchKey;
}]);

var expandParentQL = exports.expandParentQL = (0, _iflux.QL)('expandParentQL', [
//查询是否自动展开父节点
'expandParent', function (expandParent) {
  return expandParent;
}]);

var selectedQL = exports.selectedQL = (0, _iflux.QL)('selectedQL', [
//查询选中的类目
'formSource', function (formSource) {
  return formSource.get('cateId') && formSource.get('cateId').get('value') != undefined ? [formSource.get('cateId').get('value')] : [];
}]);

/**
 * 查询todo的数量
 */
var cateQL = exports.cateQL = (0, _iflux.QL)('cateQL', [
//查询类目列表
'categories', function (categories) {
  return categories;
}]);

/**
 * 查询todo的数量
 */
var cellSelectQL = exports.cellSelectQL = (0, _iflux.QL)('cellSelectQL', [
//查询选中图片
'cellSelected', function (cellSelected) {
  return cellSelected;
}]);

/**
 * 查询todo的数量
 */
var allCheckedQL = exports.allCheckedQL = (0, _iflux.QL)('allCheckedQL', [
//查询是否全选
'cellSelected', 'dataSource', function (cellSelected, dataSource) {
  var images = dataSource.filter(function (i) {
    return i.get('isCate') != 1;
  }).map(function (i) {
    return i.get('id');
  });
  if (cellSelected.count() >= images.count()) {
    if (cellSelected.keySeq().isSuperset(images)) {
      return true;
    }
  }
  return false;
}]);

var notCheckedQL = exports.notCheckedQL = (0, _iflux.QL)('notCheckedQL', [
//查询是否无选中元素
'cellSelected', 'dataSource', function (cellSelected, dataSource) {
  var images = dataSource.filter(function (i) {
    return i.get('isCate') != 1;
  }).map(function (i) {
    return i.get('id');
  });
  if (images.filter(function (i) {
    return cellSelected.has(i);
  }).size > 0) {
    return false;
  }

  return true;
}]);

/**
 * 查询todo的数量
 */
var currentDataQL = exports.currentDataQL = (0, _iflux.QL)('currentDataQL', [
//查询当前数据
'dataSource', function (dataSource) {
  return dataSource;
}]);

/**
 * 查询todo的数量
 */
var netImagesQL = exports.netImagesQL = (0, _iflux.QL)('netImagesQL', [
//查询当前数据
'netImages', function (netImages) {
  return netImages;
}]);

var imagesQL = exports.imagesQL = (0, _iflux.QL)('imagesQL', [
//查询当前数据
'images', function (images) {
  return images;
}]);

var videosQL = exports.videosQL = (0, _iflux.QL)('videosQL', [
//查询当前数据
'videos', function (videos) {
  return videos;
}]);

var selectValueQL = exports.selectValueQL = (0, _iflux.QL)('selectValueQL', ['formSource', function (formSource) {
  return formSource.get('fileType') && formSource.get('fileType').get('value') != undefined ? formSource.get('fileType').get('value') : 'all';
}]);

var linkAddressQL = exports.linkAddressQL = (0, _iflux.QL)('linkAddressQL', [
//查询当前数据
'linkAddress', function (linkAddress) {
  return linkAddress;
}]);

var fileTypeQL = exports.fileTypeQL = (0, _iflux.QL)('fileTypeQL', ['fileType', function (fileType) {
  return fileType;
}]);