'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUserSession = exports.UploadPicture = exports.saveImages = exports.checkUrl = exports.queryItems = exports.loadCategories = undefined;

var _QMFetch2 = require('qm-ux/lib/QMFetch');

var _QMFetch3 = _interopRequireDefault(_QMFetch2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadCategories = exports.loadCategories = function loadCategories() {
  var url = 'api/gallery/cate/list';
  return new Promise(function (resolve, reject) {
    (0, _QMFetch3.default)({ host: 'v_app_api', url: url }).then(function (res) {
      resolve(res);
    }, function (res) {
      reject(res);
    });
  });
};

var queryItems = exports.queryItems = function queryItems() {
  return new Promise(function (resolve, reject) {
    (0, _QMFetch3.default)({ host: 'v_app_api', url: 'api/gallery/item/list' }).then(function (res) {
      resolve(res);
    }, function (res) {
      reject(res);
    });
  });
};

/**
 * check url
 * @param {*} uri 地址图片
 * @param {*} scope 领域（店铺 or 个人中心）
 */
var checkUrl = exports.checkUrl = function checkUrl(uri, scope) {
  var url = 'api/upload/' + (scope === 'personal' ? 'user/' : '') + 'image/net?url=' + uri;
  return new Promise(function (resolve, reject) {
    (0, _QMFetch3.default)({ host: 'v_upload_api', url: url }).then(function (res) {
      resolve(res);
    }, function (res) {
      reject(res);
    });
  });
};

/**
 * save images
 * @param {*} body 
 * @param {*} scope 
 */
var saveImages = exports.saveImages = function saveImages(body, scope) {
  var url = scope === 'personal' ? 'api/user/gallery/image/save' : 'api/gallery/image/save';
  return new Promise(function (resolve, reject) {
    (0, _QMFetch3.default)({ host: 'v_app_api', url: url, body: body, method: 'POST' }).then(function (res) {
      resolve(res);
    }, function (res) {
      reject(res);
    });
  });
};

/**
 * 上传
 * @param {*} body 
 */
var UploadPicture = exports.UploadPicture = function UploadPicture(body) {
  return new Promise(function (resolve, reject) {
    (0, _QMFetch3.default)({
      host: 'v_app_api',
      url: 'api/protocol/protocolInfo',
      body: body,
      method: 'POST'
    }).then(function (res) {
      if (res.err) {
        reject(res.err.message);
      } else {
        resolve(res);
      }
    }, function (res) {
      reject(res);
    });
  });
};

var getUserSession = exports.getUserSession = function getUserSession(body) {
  return (0, _QMFetch3.default)({
    host: 'v_partner_api',
    url: 'api/getUserSession',
    method: 'GET'
  });
};