'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _QMImg2 = require('qm-ui/lib/QMImg');

var _QMImg3 = _interopRequireDefault(_QMImg2);

var _QMDialog2 = require('qm-ux/lib/QMDialog');

var _QMDialog3 = _interopRequireDefault(_QMDialog2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAsyncScriptLoader = require('react-async-script-loader');

var _reactAsyncScriptLoader2 = _interopRequireDefault(_reactAsyncScriptLoader);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _ObjectUtil = require('../util/ObjectUtil');

var _GalleryBox = require('../GalleryBox');

var _GalleryBox2 = _interopRequireDefault(_GalleryBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _QM_UM_CSS = 'qm_umeditor_css';
var _QM_UM_CSS_HREF = '//pic.qianmi.com/admin/js/plugins/umeditor/themes/default/css/umeditor.min.css';
var noop = function noop() {
  return undefined;
};

/**
 * @author gcy[of1518]
 * @date 2017.03
 */
var QMUeditor = (_dec = (0, _reactAsyncScriptLoader2.default)(['//pic.qianmi.com/admin/js/plugins/umeditor/third-party/jquery.min.js', '//pic.qianmi.com/admin/js/plugins/umeditor/third-party/template.min.js'], ['//pic.qianmi.com/admin/js/plugins/umeditor/umeditor.config.js', '//pic.qianmi.com/admin/js/plugins/umeditor/umeditor.js'], '//pic.qianmi.com/admin/js/plugins/umeditor/lang/zh-cn/zh-cn.js'), _dec(_class = (_temp = _class2 = function (_React$PureComponent) {
  _inherits(QMUeditor, _React$PureComponent);

  function QMUeditor(props) {
    _classCallCheck(this, QMUeditor);

    var _this = _possibleConstructorReturn(this, (QMUeditor.__proto__ || Object.getPrototypeOf(QMUeditor)).call(this, props));

    _this.ueEditor = {};

    _this.initUeditor = function () {
      var onChange = _this.props.onChange;

      _this.ueEditor = UM.getEditor('ueditor', (0, _objectAssign2.default)({
        toolbar: ['source | undo redo | bold italic underline strikethrough | superscript subscript | forecolor backcolor | removeformat |', 'insertorderedlist insertunorderedlist | selectall cleardoc | fontfamily fontsize', '| justifyleft justifycenter justifyright justifyjustify |', 'link unlink | image video  | map', '| horizontal preview fullscreen', 'drafts', 'formula'],
        zIndex: 850,
        initialFrameHeight: 400,
        autoHeightEnabled: true,
        wordCount: false,
        disabledTableInTable: false,
        videoAllowFiles: []
      }, _this.props.options || {}));
      _this.ueEditor.ready(function () {
        _this.props.ready(_this.ueEditor);
        _this.ueEditor.addListener('contentChange', function () {
          return onChange(_this.ueEditor.getContent());
        });
        _this.ueEditor.addListener('contentChange', function () {
          return onChange(_this.ueEditor.getContent());
        });
      });
    };

    _this.appendStyleElement = function () {
      var node = document.getElementById(_QM_UM_CSS);
      if (!!node) {
        node.href = _QM_UM_CSS_HREF;
      } else {
        var link = document.createElement('link');
        link.id = _QM_UM_CSS;
        link.rel = 'stylesheet';
        link.href = _QM_UM_CSS_HREF;
        document.head.appendChild(link);
      }
    };

    _this.removeStyleElement = function () {
      var node = document.getElementById(_QM_UM_CSS);
      node.href = '';
    };

    _this.state = {
      valueInitial: false

      //全局添加
    };window.gallery = function (_selected) {
      return _QMDialog3.default.load(_react2.default.createElement(_GalleryBox2.default, { hash: '_gallery', limit: 10 - _selected }), {
        width: 800,
        title: '选择图片',
        className: 'modal-custom select-picture-library'
      }).then(function (res) {
        return (res || []).map(function (i) {
          return _QMImg3.default.src({ src: i.path });
        });
      });
    };

    //dom对象写入link标签
    _this.appendStyleElement();
    return _this;
  }

  _createClass(QMUeditor, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var isScriptLoaded = _ref.isScriptLoaded,
          isScriptLoadSucceed = _ref.isScriptLoadSucceed,
          content = _ref.content;

      if (isScriptLoaded && !this.props.isScriptLoaded) {
        // load finished
        if (isScriptLoadSucceed) {
          this.initUeditor();
        }
      } else if (this.props.isScriptLoaded) {
        var self = this;
        var valueInitial = this.state.valueInitial;

        if (!valueInitial && this.props.async) {
          this.setState({ valueInitial: true }, function () {
            return self.ueEditor.setContent(content);
          });
        }
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          isScriptLoaded = _props.isScriptLoaded,
          isScriptLoadSucceed = _props.isScriptLoadSucceed;

      if (isScriptLoaded && isScriptLoadSucceed) {
        this.initUeditor();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      //组件注销时，销毁ue对象
      UM.delEditor('ueditor');

      //组件注册时，销毁css
      this.removeStyleElement();
    }
  }, {
    key: 'render',
    value: function render() {
      var _splitObject = (0, _ObjectUtil.splitObject)(this.props, ['id', 'style']),
          _splitObject2 = _slicedToArray(_splitObject, 2),
          props = _splitObject2[0],
          content = _splitObject2[1].content;

      content = content || '';
      return _react2.default.createElement('script', _extends({ ref: '_qm_ueditor' }, props, { dangerouslySetInnerHTML: { __html: content } }));
    }

    /**
     * init
     */


    /**
     * 注册css
     */


    /**
     * 销毁css
     */

  }]);

  return QMUeditor;
}(_react2.default.PureComponent), _class2.defaultProps = {
  id: 'ueditor',
  content: '',
  async: false,
  style: { width: '100%', height: '280px' },
  onChange: noop,
  ready: noop
}, _temp)) || _class);
exports.default = QMUeditor;