'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * @author gcy[of1518]
 * @date 2017.02
 *
 * @description 对象拓展工具类
 */

/**
 * 空对象判断
 */
var isEmptyObject = function isEmptyObject() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) == 'object' && Object.keys(obj).length === 0;
};
exports.isEmptyObject = isEmptyObject;

/**
 * component props 拆分props
 * @param {object} obj props
 * @param {object} parts props container
 */
var splitObject = function splitObject(obj, parts) {
  var extra = {};
  var orign = {};
  Object.keys(obj).forEach(function (v) {
    parts.indexOf(v) !== -1 ? extra[v] = obj[v] : orign[v] = obj[v];
  });
  return [extra, orign];
};
exports.splitObject = splitObject;

/**
 * 对象包装
 * @param {object} obj  {_hash:0937343,id:001001}
 * @param {Array} parts ['_hash', ''], ['id:pid', 0], ['bn', 999],
 * @return {object} result {_hash:0937343,pid:001001,bn:999}
 */
var collectObject = function collectObject(obj, parts) {
  var result = {};
  var orign = Object.keys(obj);
  parts.forEach(function (v, k) {
    var _v = _slicedToArray(v, 2),
        name = _v[0],
        defaultValue = _v[1];

    var oldName = '',
        newName = '';
    if (name.indexOf(':') !== -1) {
      ;
      var _name$split = name.split(':');

      var _name$split2 = _slicedToArray(_name$split, 2);

      oldName = _name$split2[0];
      newName = _name$split2[1];
    } else {
      ;oldName = name;
      newName = name;
    }
    if (orign.indexOf(oldName) !== -1) {
      result[newName] = obj[oldName];
    } else {
      result[newName] = defaultValue;
    }
  });
  return result;
};
exports.collectObject = collectObject;