import GA from './adapters/ga'
import UMeng from './adapters/umeng'

let GH = {
  init: options => {
    if (options && options.ga) {
      GA.initialize(options.ga)
    }
    if (options && options.umeng) {
      UMeng.initialize(options.umeng)
    }
  },
  setScene: s => {
    UMeng.setDimension('场景', s)
    GA.set({ dimension1: s })
  },
  setRole: r => {
    UMeng.setDimension('角色', r)
    GA.set({ dimension2: r })
  },
  setUserId: u => {
    UMeng.setDimension('店铺编号', u)
    GA.set({ userId: u })
  },
  setUserTag: t => {
    UMeng.setDimension('用户标签', t)
    GA.set({ dimension4: t })
  },
  setEmp: e => {
    UMeng.setDimension('员工', e)
    GA.set({ dimension3: e })
  },
  setVersion: v => {
    UMeng.setDimension('版本', v)
    GA.set({ dimension5: v })
  },
  setTrial: t => {
    UMeng.setDimension('试用用户', t)
    GA.set({ dimension6: t })
  },
  setLifeCycle: c => {
    UMeng.setDimension('生命周期', c)
    GA.set({ dimension7: c })
  },
  setClientVersion: sv => {
    UMeng.setDimension('客户端版本', sv)
    GA.set({ dimension8: sv })
  },
  setPageview: (route, referer) => {
    UMeng.setPageview(route, referer)
    GA.pageview(route, referer)
  },
  setEvent: (category, action, label, value, nodeid) => {
    UMeng.setEvent(category, action, label, value, nodeid)
    if (GA && GA.ga) {
      GA.ga('send', 'event', category, action, label)
    }
  },
}

export default GH
