import { Action, Actor } from 'iflux2'

export default class GalleryActor extends Actor {
  defaultState() {
    return {
      view: 'selector', // 视图类型：selector | upload | protocol
      searchKey: '',
      limit: 0,
      scope: 'shop', // 图库，shop 店铺级别，personal 千米ID 级别,
      fileType: 'all', // 组件筛选文件类型。。 all 所有文件，pic 图片， video 视频
    }
  }

  @Action('gallery:view')
  switch(state, value) {
    return state.set('view', value)
  }

  @Action('gallery:searchKey')
  search(state, key) {
    return state.set('searchKey', key)
  }

  @Action('gallery:update:limit')
  setLimit(state, value) {
    return state.set('limit', value)
  }

  @Action('gallery:update:scope')
  setScope(state, value) {
    return state.set('scope', value)
  }

  @Action('gallery:update:fileType')
  setFileType(state, value) {
    return state.set('fileType', value)
  }
}
