import { QMFetch } from 'qm-ux'

export const loadCategories = () => {
  let url = 'api/gallery/cate/list'
  return new Promise((resolve, reject) => {
    QMFetch({ host: 'v_app_api', url }).then(
      res => {
        resolve(res)
      },
      res => {
        reject(res)
      }
    )
  })
}

export const queryItems = () => {
  return new Promise((resolve, reject) => {
    QMFetch({ host: 'v_app_api', url: 'api/gallery/item/list' }).then(
      res => {
        resolve(res)
      },
      res => {
        reject(res)
      }
    )
  })
}

/**
 * check url
 * @param {*} uri 地址图片
 * @param {*} scope 领域（店铺 or 个人中心）
 */
export const checkUrl = (uri, scope) => {
  const url = `api/upload/${scope === 'personal' ? 'user/' : ''}image/net?url=${uri}`
  return new Promise((resolve, reject) => {
    QMFetch({ host: 'v_upload_api', url }).then(
      res => {
        resolve(res)
      },
      res => {
        reject(res)
      }
    )
  })
}

/**
 * save images
 * @param {*} body 
 * @param {*} scope 
 */
export const saveImages = (body, scope) => {
  let url = scope === 'personal' ? 'api/user/gallery/image/save' : 'api/gallery/image/save'
  return new Promise((resolve, reject) => {
    QMFetch({ host: 'v_app_api', url, body: body, method: 'POST' }).then(
      res => {
        resolve(res)
      },
      res => {
        reject(res)
      }
    )
  })
}

/**
 * 上传
 * @param {*} body 
 */
export const UploadPicture = body => {
  return new Promise((resolve, reject) => {
    QMFetch({
      host: 'v_app_api',
      url: 'api/protocol/protocolInfo',
      body: body,
      method: 'POST',
    }).then(
      res => {
        if (res.err) {
          reject(res.err.message)
        } else {
          resolve(res)
        }
      },
      res => {
        reject(res)
      }
    )
  })
}

export const getUserSession = body => {
  return QMFetch({
    host: 'v_partner_api',
    url: 'api/getUserSession',
    method: 'GET',
  })
}
