import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { QMIcon } from 'qm-ui'
import { Popover } from 'antd'

const { object } = PropTypes

export default class PageTip extends Component {
  static defaultProps = {
    name: '',
    placement: '',
  }

  render() {
    let { tipMap = {} } = this.context
    let { name, placement, className } = this.props || {}
    if (!name) {
      return null
    }
    let tip = tipMap[name]
    if (!tip || !tip.content) {
      return null
    }
    let content = (
      <div className="page-in-content" dangerouslySetInnerHTML={{ __html: tip.content }} />
    )
    return (
      <Popover content={content} placement={placement || tip.position || 'bottom'}>
        <span className={'page-in-help-tips ' + className || ''}>
          <QMIcon type="xinXi2" />
        </span>
      </Popover>
    )
  }
}

PageTip.contextTypes = {
  tipMap: object,
}
